package com.eactive.eai.rms.bap.manage.comm.sysinfo;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.eactive.eai.agent.command.CommonCommand;
import com.eactive.eai.rms.common.base.BapBaseAnnotationController;
import com.eactive.eai.rms.common.login.SessionManager;
import com.eactive.eai.rms.common.util.CamelCaseUtil;
import com.eactive.eai.rms.common.vo.JsonPageVo;

@Controller
public class BapSysinfoController extends BapBaseAnnotationController  {

	@Autowired
	@Qualifier("bapSysinfoService")
	private BapSysinfoService service;
	
	@RequestMapping(value= "/bap/admin/common/sysinfoMan.view")
	public String viewList(HttpServletRequest request, @RequestParam(value = "cmd", required = false ) String cmd ) throws Exception {
		if (cmd == null || "LIST".equals(cmd.toUpperCase())){
			cmd = "";
		}else {
			cmd = CamelCaseUtil.converCamelCase(cmd);
		}
		String path = request.getServletPath();
		return path.split("[.]")[0]+cmd;
	}
	
	/**
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	@RequestMapping(value= "/bap/admin/common/sysinfoMan.json", params = "cmd=LIST")
	public ModelAndView selectList(HttpServletRequest request,
			JsonPageVo pageVo ,@RequestParam HashMap<String, Object> paramMap) throws Exception {
		
		HashMap<String, Object> map = service.selectList( pageVo.getStartNum(), pageVo.getEndNum(), paramMap);
		
		pageVo.setTotalCount((Integer)map.get("totalCount"));
		
		Map<String, Object> resultMap = new HashMap<String, Object>();
		resultMap.put("total"  , pageVo.getTotal());  //전체 페이지수
		resultMap.put("page"   , pageVo.getPage());   //현재 페이지수
		resultMap.put("records", pageVo.getTotalCount());//전체 레코드건수	
		resultMap.put("rows"   , map.get("list"));
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
		
	}

	@RequestMapping(value= "/bap/admin/common/sysinfoMan.json",params = "cmd=DETAIL")
	public ModelAndView selectDetail(HttpServletRequest request,
			HttpServletResponse response, String sysCd) throws Exception {
		
		HashMap<String, Object> map = service.selectDetail(sysCd);

		ModelAndView modelAndView = new ModelAndView("jsonView", map);	
		
		return modelAndView;
	}
	@RequestMapping(value= "/bap/admin/common/sysinfoMan.json",params = "cmd=INSERT")
	public String insert(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> paramMap) throws Exception {

		String userid = SessionManager.getUserId(request);
		paramMap.put("userid", userid );

		service.insert(paramMap);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.sysinfo.UpdateSysinfoCommand",(String)paramMap.get("sysCd"));
		agentUtilService.broadcast(command);
		return null;
		
	}	
	@RequestMapping(value= "/bap/admin/common/sysinfoMan.json",params = "cmd=UPDATE")
	public String update(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> paramMap ) throws Exception {

		String userid = SessionManager.getUserId(request);
		paramMap.put("userid", userid );

		service.update(paramMap);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.sysinfo.UpdateSysinfoCommand",(String)paramMap.get("sysCd"));
		agentUtilService.broadcast(command);

		return null;
		
	}
	@RequestMapping(value= "/bap/admin/common/sysinfoMan.json",params = "cmd=DELETE")
	public String delete(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> paramMap ) throws Exception {
		service.delete(paramMap);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.sysinfo.RemoveSysinfoCommand",(String)paramMap.get("sysCd"));
		agentUtilService.broadcast(command);
		return null;
		
	}	
}